Index: admin/js/jquery/jquery.pageTabs.js
===================================================================
--- admin/js/jquery/jquery.pageTabs.js	(revision 2479)
+++ admin/js/jquery/jquery.pageTabs.js	(revision 3333)
@@ -1,5 +1,5 @@
 (function($) {
 	'use strict';
-    
+
 	$.pageTabs = function(start_tab, opts) {
 		var defaults = {
@@ -10,8 +10,9 @@
 			idTabPrefix: 'part-tabs-'
 		};
-		
+
 		$.pageTabs.options = $.extend({}, defaults, opts);
 		var active_tab = start_tab || '';
 		var hash = $.pageTabs.getLocationHash();
+		var subhash = $.pageTabs.getLocationSubhash();
 
 		if (hash !== undefined && hash) {
@@ -23,5 +24,5 @@
 
 		createTabs();
-		
+
 		$('ul li', '.'+$.pageTabs.options.containerClass).click(function(e) {
 			if ($(this).hasClass($.pageTabs.options.activeClass)) {
@@ -40,5 +41,5 @@
 				part_to_activate.addClass('loaded');
 			}
-			
+
 			part_to_activate.tabload();
 		});
@@ -49,11 +50,16 @@
 
 		$.pageTabs.clickTab(active_tab);
-		
+
+		if (subhash !== undefined) {
+			// Tab displayed, now scroll to the sub-part if defined in original document.location (#tab.sub-part)
+			document.getElementById(subhash).scrollIntoView();
+		}
+
 		return this;
 	};
-	
+
 	var createTabs = function createTabs() {
 		var lis = [], li_class = '';
-		
+
 		$('.'+$.pageTabs.options.contentClass).each(function() {
 			$(this).hide();
@@ -62,9 +68,9 @@
 			$(this).attr('id', $.pageTabs.options.partPrefix + $(this).attr('id')).prop('title','');
 		});
-		
+
 		$('<div class="'+$.pageTabs.options.containerClass+'"><ul>'+lis.join('')+'</ul></div>')
 			.insertBefore($('.'+$.pageTabs.options.contentClass).get(0));
 	};
-	
+
 	var getHash = function getHash(href) {
 		var href = href || '';
@@ -72,5 +78,5 @@
 		return href.replace(/.*#/, '');
 	};
-	
+
 	$.pageTabs.clickTab = function(tab) {
 		if (tab=='') {
@@ -96,5 +102,12 @@
 
 	$.pageTabs.getLocationHash = function() {
-		return getHash(document.location.hash);
+		// Return the URL hash (without subhash — #hash[.subhash])
+		var h = getHash(document.location.hash).split('.');
+		return h[0];
+	};
+	$.pageTabs.getLocationSubhash = function() {
+		// Return the URL subhash if present (without hash — #hash[.subhash])
+		var sh = getHash(document.location.hash).split('.');
+		return sh[1];
 	};
 })(jQuery);
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3295)
+++ admin/media.php	(revision 3369)
@@ -35,5 +35,5 @@
 
 $page = !empty($_GET['page']) ? max(1,(integer) $_GET['page']) : 1;
-$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ? (integer) $core->auth->user_prefs->interface->media_by_page : 30);
+$nb_per_page = ((integer) $core->auth->user_prefs->interface->media_by_page ?: 30);
 
 # We are on home not comming from media manager
@@ -75,8 +75,14 @@
 $file_mode = !empty($_SESSION['media_file_mode']) ? $_SESSION['media_file_mode'] : 'grid';
 
-if (!empty($_GET['file_sort']) && in_array($_GET['file_sort'],$sort_combo)) {
-	$_SESSION['media_file_sort'] = $_GET['file_sort'];
-}
-$file_sort = !empty($_SESSION['media_file_sort']) ? $_SESSION['media_file_sort'] : null;
+$file_sort = null;
+if (!empty($_GET['file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'] = $_GET['file_sort'];
+	setcookie('dc_media_sort',json_encode($file_sort));
+} elseif (isset($_COOKIE['dc_media_sort'])) {
+	$file_sort = json_decode($_COOKIE['dc_media_sort']);
+} elseif (!empty($_SESSION['media_file_sort'])) {
+	$file_sort = $_SESSION['media_file_sort'];
+}
+$file_sort =  in_array($file_sort,$sort_combo) ? $file_sort : null;
 
 $nb_per_page = !empty($_SESSION['nb_per_page']) ? (integer)$_SESSION['nb_per_page'] : $nb_per_page;
@@ -155,5 +161,5 @@
 			$zip->addDirectory($core->media->root.'/'.$d,'',true);
 
-			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ? $d : 'media').'.zip');
+			header('Content-Disposition: attachment;filename='.date('Y-m-d').'-'.$core->blog->id.'-'.($d ?: 'media').'.zip');
 			header('Content-Type: application/x-zip');
 			$zip->write();
@@ -510,4 +516,5 @@
 
 call_user_func($open_f,__('Media manager'),
+	dcPage::jsModal().
 	dcPage::jsLoad('js/_media.js').
 	($core_media_writable ? dcPage::jsUpload(array('d='.$d)) : ''),
@@ -960,4 +967,7 @@
 	}
 
+	$file_type = explode('/',$f->type);
+	$class_open = 'class="modal-'.$file_type[0].'" ';
+
 	// Render markup
 	if (!$table) {
@@ -973,5 +983,5 @@
 			$f->media_dtstr.' - '.
 			files::size($f->size).' - '.
-			'<a href="'.$f->file_url.'">'.__('open').'</a>'.
+			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>'.
 			'</li>';
 		}
@@ -979,5 +989,4 @@
 
 		// Show player if relevant
-		$file_type = explode('/',$f->type);
 		if ($file_type[0] == 'audio')
 		{
@@ -994,5 +1003,6 @@
 				'<br />'.($f->d ? '' : $f->media_title).'</td>';
 		$res .= '<td class="nowrap count">'.($f->d ? '' : $f->media_dtstr).'</td>';
-		$res .= '<td class="nowrap count">'.($f->d ? '' : files::size($f->size).' - '.'<a href="'.$f->file_url.'">'.__('open').'</a>').'</td>';
+		$res .= '<td class="nowrap count">'.($f->d ? '' : files::size($f->size).' - '.
+			'<a '.$class_open.'href="'.$f->file_url.'">'.__('open').'</a>').'</td>';
 		$res .= '</tr>';
 	}
Index: admin/media_item.php
===================================================================
--- admin/media_item.php	(revision 3167)
+++ admin/media_item.php	(revision 3369)
@@ -185,5 +185,5 @@
 
 # Function to get image title based on meta
-function dcGetImageTitle($file,$pattern,$dto_first=false,$no_date_alone=false)
+$get_img_title = function ($file,$pattern,$dto_first=false,$no_date_alone=false)
 {
 	$res = array();
@@ -225,5 +225,5 @@
 	}
 	return implode($sep,$res);
-}
+};
 
 /* DISPLAY Main page
@@ -235,4 +235,5 @@
 	"//]]>".
 	"</script>".
+	dcPage::jsModal().
 	dcPage::jsLoad('js/_media_item.js');
 if ($popup && !empty($plugin_id)) {
@@ -307,5 +308,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
@@ -376,5 +377,5 @@
 	{
 		$media_type = 'image';
-		$media_desc = dcGetImageTitle($file,
+		$media_desc = $get_img_title($file,
 			$core->blog->settings->system->media_img_title_pattern,
 			$core->blog->settings->system->media_img_use_dto_first,
@@ -554,10 +555,14 @@
 
 	if (isset($file->media_thumb[$thumb_size])) {
-		echo '<p><img src="'.$file->media_thumb[$thumb_size].'?'.time()*rand().'" alt="" /></p>';
+		echo '<p><a class="modal-image" href="'.$file->file_url.'">'.
+			'<img src="'.$file->media_thumb[$thumb_size].'?'.time()*rand().'" alt="" />'.
+			'</a></p>';
 	} elseif ($thumb_size == 'o') {
 		$S = getimagesize($file->file);
 		$class = ($S[1] > 500) ? ' class="overheight"' : '';
 		unset($S);
-		echo '<p id="media-original-image"'.$class.'><img src="'.$file->file_url.'?'.time()*rand().'" alt="" /></p>';
+		echo '<p id="media-original-image"'.$class.'><a class="modal-image" href="'.$file->file_url.'">'.
+			'<img src="'.$file->file_url.'?'.time()*rand().'" alt="" />'.
+			'</a></p>';
 	}
 
Index: admin/plugin.php
===================================================================
--- admin/plugin.php	(revision 2708)
+++ admin/plugin.php	(revision 3333)
@@ -78,4 +78,11 @@
 	call_user_func($open_f,$p_title,$p_head);
 	echo $p_content;
+	if (!$popup) {
+		// Add direct links to plugin settings if any
+		$settings = adminModulesList::getSettingsUrls($core,$p,true,false);
+		if (!empty($settings)) {
+			echo '<hr class="clear"/><p class="right modules">'.implode(' - ',$settings).'</p>';
+		}
+	}
 	call_user_func($close_f);
 }
Index: admin/popup_posts.php
===================================================================
--- admin/popup_posts.php	(revision 2971)
+++ admin/popup_posts.php	(revision 3375)
@@ -50,5 +50,5 @@
 echo '<h2 class="page-title">'.__('Add a link to an entry').'</h2>';
 
-echo '<form action="popup_posts.php" method="get">'.
+echo '<form action="'.$core->adminurl->get('admin.popup_posts').'" method="get">'.
 	'<p><label for="type" class="classic">'.__('Entry type:').'</label> '.form::combo('type',$type_combo,$type).''.
 	'<noscript><div><input type="submit" value="'.__('Ok').'" /></div></noscript>'.
@@ -56,5 +56,5 @@
 	'</form>';
 
-echo '<form action="popup_posts.php" method="get">'.
+echo '<form action="'.$core->adminurl->get('admin.popup_posts').'" method="get">'.
 	'<p><label for="q" class="classic">'.__('Search entry:').'</label> '.form::field('q',30,255,html::escapeHTML($q)).
 	' <input type="submit" value="'.__('Search').'" />'.
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 3209)
+++ admin/post.php	(revision 3340)
@@ -272,5 +272,5 @@
 
 	$cur->post_title = $post_title;
-	$cur->cat_id = ($cat_id ? $cat_id : null);
+	$cur->cat_id = ($cat_id ?: null);
 	$cur->post_dt = $post_dt ? date('Y-m-d H:i:00',strtotime($post_dt)) : '';
 	$cur->post_format = $post_format;
Index: admin/posts.php
===================================================================
--- admin/posts.php	(revision 3209)
+++ admin/posts.php	(revision 3360)
@@ -136,4 +136,10 @@
 	__('Number of trackbacks') => 'nb_trackback'
 	);
+
+	$sortby_lex = array(
+		// key in sorty_combo (see above) => field in SQL request
+		'post_title' => 'post_title',
+		'cat_title' => 'cat_title',
+		'user_id' => 'P.user_id');
 
 	$order_combo = array(
@@ -275,6 +281,11 @@
 # - Sortby and order filter
 if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if (array_key_exists($sortby,$sortby_lex)) {
+		$params['order'] = $core->con->lexFields($sortby_lex[$sortby]);
+	} else {
+		$params['order'] = $sortby;
+	}
 	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
+		$params['order'] .= ' '.$order;
 	} else {
 		$order='desc';
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3265)
+++ admin/preferences.php	(revision 3340)
@@ -47,5 +47,5 @@
 $user_ui_iconset = @$core->auth->user_prefs->interface->iconset;
 $user_ui_nofavmenu = $core->auth->user_prefs->interface->nofavmenu;
-$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ? $core->auth->user_prefs->interface->media_by_page : 30);
+$user_ui_media_by_page = ($core->auth->user_prefs->interface->media_by_page ?: 30);
 $user_ui_media_nb_last_dirs = $core->auth->user_prefs->interface->media_nb_last_dirs;
 
@@ -98,4 +98,21 @@
 # Language codes
 $lang_combo = dcAdminCombos::getAdminLangsCombo();
+
+# Get 3rd parts xhtml editor flags
+$rte = array(
+	'blog_descr' => array(true,__('Blog description (in blog parameters)')),
+	'cat_descr' => array(true,__('Category description'))
+);
+$rte = new ArrayObject($rte);
+$core->callBehavior('adminRteFlags',$core,$rte);
+# Load user settings
+$rte_flags = @$core->auth->user_prefs->interface->rte_flags;
+if (is_array($rte_flags)) {
+	foreach ($rte_flags as $fk => $fv) {
+		if (isset($rte[$fk])) {
+			$rte[$fk][0] = $fv;
+		}
+	}
+}
 
 # Get default colums (admin lists)
@@ -233,4 +250,11 @@
 		}
 		$core->auth->user_prefs->interface->put('cols',$cu,'array');
+
+		# Update user xhtml editor flags
+		$rf = array();
+		foreach ($rte as $rk => $rv) {
+			$rf[$rk] = isset($_POST['rte_flags']) && in_array($rk,$_POST['rte_flags'],true) ? true : false;
+		}
+		$core->auth->user_prefs->interface->put('rte_flags',$rf,'array');
 
 		# Update user
@@ -466,5 +490,5 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Interface').'</h4>'.
+'<h4 id="user_options_interface">'.__('Interface').'</h4>'.
 
 '<p><label for="user_ui_enhanceduploader" class="classic">'.
@@ -500,12 +524,16 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Optional columns displayed in lists').'</h4>';
+'<h4 id="user_options_columns">'.__('Optional columns displayed in lists').'</h4>';
+$odd = true;
 foreach ($cols as $col_type => $col_list) {
+	echo '<div class="two-boxes '.($odd ? 'odd' : 'even').'">';
 	echo '<h5>'.$col_list[0].'</h5>';
 	foreach ($col_list[1] as $col_name => $col_data) {
 		echo
-		'<p><label for="cols_'.$col_type.'-"'.$col_name.'" class="classic">'.
+		'<p><label for="cols_'.$col_type.'-'.$col_name.'" class="classic">'.
 		form::checkbox(array('cols_'.$col_type.'[]','cols_'.$col_type.'-'.$col_name),$col_name,$col_data[0]).$col_data[1].'</label>';
 	}
+	echo '</div>';
+	$odd = !$odd;
 }
 echo '</div>';
@@ -513,6 +541,7 @@
 echo
 '<div class="fieldset">'.
-'<h4>'.__('Edition').'</h4>';
-
+'<h4 id="user_options_edition">'.__('Edition').'</h4>';
+
+echo '<div class="two-boxes odd">';
 foreach ($format_by_editors as $format => $editors) {
 	echo
@@ -544,4 +573,15 @@
 
 '</div>';
+
+echo '<div class="two-boxes even">';
+echo '<h5>'.__('Use xhtml editor for:').'</h5>';
+foreach ($rte as $rk => $rv) {
+	echo
+		'<p><label for="rte_'.$rk.'" class="classic">'.
+		form::checkbox(array('rte_flags[]','rte_'.$rk),$rk,$rv[0]).$rv[1].'</label>';
+}
+echo '</div>';
+
+echo '</div>';	// fieldset
 
 echo
Index: admin/style/config.rb
===================================================================
--- admin/style/config.rb	(revision 3355)
+++ admin/style/config.rb	(revision 3355)
@@ -0,0 +1,19 @@
+# Require any additional compass plugins here.
+
+# Set this to the root of your project when deployed:
+http_path = "./"
+css_dir = "./"
+sass_dir = "scss"
+images_dir = "img"
+javascripts_dir = "scripts"
+
+# You can select your preferred output style here (can be overridden via the command line):
+# output_style = :expanded or :nested or :compact or :compressed
+# To enable relative paths to assets via compass helper functions. Uncomment:
+# relative_assets = true
+# To disable debugging comments that display the original location of your selectors. Uncomment:
+output_style = :nested
+environment = :development
+line_comments = false
+
+Sass::Script::Number.precision = 7
Index: admin/users.php
===================================================================
--- admin/users.php	(revision 3182)
+++ admin/users.php	(revision 3360)
@@ -23,4 +23,11 @@
 __('Number of entries') => 'nb_post'
 );
+
+$sortby_lex = array(
+	// key in sorty_combo (see above) => field in SQL request
+	'user_id' => 'U.user_id',
+	'user_name' => 'user_name',
+	'user_firstname' => 'user_firstname',
+	'user_displayname' => 'user_displayname');
 
 $order_combo = array(
@@ -66,6 +73,11 @@
 # - Sortby and order filter
 if ($sortby !== '' && in_array($sortby,$sortby_combo)) {
+	if (array_key_exists($sortby,$sortby_lex)) {
+		$params['order'] = $core->con->lexFields($sortby_lex[$sortby]);
+	} else {
+		$params['order'] = $sortby;
+	}
 	if ($order !== '' && in_array($order,$order_combo)) {
-		$params['order'] = $sortby.' '.$order;
+		$params['order'] .= ' '.$order;
 	} else {
 		$order='asc';
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3319)
+++ inc/admin/lib.dc.page.php	(revision 3373)
@@ -106,8 +106,8 @@
 			// Get directives from settings if exist, else set defaults
 			$csp = new ArrayObject(array());
-			$csp['default-src'] = $core->blog->settings->system->csp_admin_default ? $core->blog->settings->system->csp_admin_default : "'self'";
-			$csp['script-src'] = $core->blog->settings->system->csp_admin_script ? $core->blog->settings->system->csp_admin_script : "'self' 'unsafe-inline' 'unsafe-eval'";
-			$csp['style-src'] = $core->blog->settings->system->csp_admin_style ? $core->blog->settings->system->csp_admin_style : "'self' 'unsafe-inline'";
-			$csp['img-src'] = $core->blog->settings->system->csp_admin_img ? $core->blog->settings->system->csp_admin_img : "'self' data: media.dotaddict.org";
+			$csp['default-src'] = $core->blog->settings->system->csp_admin_default ?: "'self'";
+			$csp['script-src'] = $core->blog->settings->system->csp_admin_script ?: "'self' 'unsafe-inline' 'unsafe-eval'";
+			$csp['style-src'] = $core->blog->settings->system->csp_admin_style ?: "'self' 'unsafe-inline'";
+			$csp['img-src'] = $core->blog->settings->system->csp_admin_img ?: "'self' data: media.dotaddict.org";
 
 			# Cope with blog post preview (via public URL in iframe)
@@ -137,5 +137,6 @@
 					$directives[] = "report-uri ".DC_ADMIN_URL."csp_report.php";
 				}
-				$headers['csp'] = "Content-Security-Policy: ".implode(" ; ",$directives);
+				$report_only = ($core->blog->settings->system->csp_admin_report_only) ? '-Report-Only' : '';
+				$headers['csp'] = "Content-Security-Policy".$report_only.": ".implode(" ; ",$directives);
 			}
 		}
@@ -211,6 +212,6 @@
 		'<div id="wrapper" class="clearfix">'."\n".
 		'<div class="hidden-if-no-js collapser-box"><a href="#" id="collapser">'.
-		'<img class="collapse-mm" src="images/collapser-hide.png" alt="'.__('Hide main menu').'" />'.
-		'<img class="expand-mm" src="images/collapser-show.png" alt="'.__('Show main menu').'" />'.
+		'<img class="collapse-mm visually-hidden" src="images/collapser-hide.png" alt="'.__('Hide main menu').'" />'.
+		'<img class="expand-mm visually-hidden" src="images/collapser-show.png" alt="'.__('Show main menu').'" />'.
 		'</a></div>'.
 		'<div id="main" role="main">'."\n".
@@ -297,5 +298,5 @@
 	{
 		global $core;
-		$tag = (isset($n['divtag'])&& $n['divtag'])?'div':'p';
+		$tag = (isset($n['divtag']) && $n['divtag']) ? 'div' : 'p';
 		$ts = '';
 		if (!isset($n['with_ts']) || ($n['with_ts'] == true)) {
@@ -441,7 +442,7 @@
 	{
 		global $core;
-		$with_home_link = isset($options['home_link'])?$options['home_link']:true;
-		$hl = isset($options['hl'])?$options['hl']:true;
-		$hl_pos = isset($options['hl_pos'])?$options['hl_pos']:-1;
+		$with_home_link = isset($options['home_link']) ? $options['home_link'] : true;
+		$hl = isset($options['hl']) ? $options['hl'] : true;
+		$hl_pos = isset($options['hl_pos']) ? $options['hl_pos'] : -1;
 		// First item of array elements should be blog's name, System or Plugins
 		$res = '<h2>'.($with_home_link ?
@@ -864,12 +865,5 @@
 	{
 		return
-		self::cssLoad('style/modal/modal.css').
-		self::jsLoad('js/jquery/jquery.modal.js').
-		'<script type="text/javascript">'."\n".
-		"//<![CDATA[\n".
-		self::jsVar('$.modal.prototype.params.loader_img','style/modal/loader.gif').
-		self::jsVar('$.modal.prototype.params.close_img','style/modal/close.png').
-		"\n//]]>\n".
-		"</script>\n";
+		self::jsLoad('js/jquery/jquery.magnific-popup.js');
 	}
 
@@ -978,16 +972,4 @@
 	}
 
-	public static function jsToolMan()
-	{
-		return
-		self::jsLoad('js/tool-man/core.js').
-		self::jsLoad('js/tool-man/events.js').
-		self::jsLoad('js/tool-man/css.js').
-		self::jsLoad('js/tool-man/coordinates.js').
-		self::jsLoad('js/tool-man/drag.js').
-		self::jsLoad('js/tool-man/dragsort.js').
-		self::jsLoad('js/dragsort-tablerows.js');
-	}
-
 	public static function jsMetaEditor()
 	{
@@ -1053,4 +1035,5 @@
 					}
 				}
+				sort($themes);
 			}
 		}
Index: inc/admin/lib.moduleslist.php
===================================================================
--- inc/admin/lib.moduleslist.php	(revision 3327)
+++ inc/admin/lib.moduleslist.php	(revision 3338)
@@ -466,5 +466,7 @@
 				'sshot' 			=> '',
 				'score'				=> 0,
-				'type' 				=> null
+				'type' 				=> null,
+				'require'			=> array(),
+				'settings'			=> array()
 			),
 			# Module's values
@@ -744,5 +746,5 @@
 					if (!empty($more)) {
 						echo
-						'<li>'.implode(' - ', $more).'</li>';
+						'<li>'.implode(' - ',$more).'</li>';
 					}
 
@@ -752,12 +754,17 @@
 
 				$config = !empty($module['root']) && file_exists(path::real($module['root'].'/_config.php'));
-
-				if ($config || !empty($module['section']) || !empty($module['tags'])) {
+				$index = !empty($module['root']) && file_exists(path::real($module['root'].'/index.php'));
+
+				if ($config || $index || !empty($module['section']) || !empty($module['tags']) || !empty($module['settings'])) {
 					echo
 					'<div><ul class="mod-more">';
 
-					if ($config) {
-						echo
-						'<li><a class="module-config" href="'.$this->getURL('module='.$id.'&amp;conf=1').'">'.__('Configure plugin').'</a></li>';
+					if ($index && $module['enabled']) {
+						echo '<li><a href="'.$this->core->adminurl->get('admin.plugin.'.$id).'">'.__('Manage plugin').'</a></li>';
+					}
+
+					$settings = $this->getSettingsUrls($this->core,$id);
+					if (!empty($settings) && $module['enabled']) {
+						echo '<li>'.implode(' - ',$settings).'</li>';
 					}
 
@@ -806,4 +813,78 @@
 
 		return $this;
+	}
+
+	/**
+	 * Get settings URLs if any
+	 *
+	 * @param object $core
+	 * @param string $id module ID
+	 * @param boolean $check check permission
+	 * @param boolean $self include self URL (→ plugin index.php URL)
+	 * @return Array of settings URLs
+	 */
+	public static function getSettingsUrls($core,$id,$check=false,$self=true)
+	{
+		$st = array();
+
+		$config = !empty($core->plugins->moduleRoot($id)) &&
+			file_exists(path::real($core->plugins->moduleRoot($id).'/_config.php'));
+		$settings = $core->plugins->moduleInfo($id,'settings');
+		if ($config || !empty($settings)) {
+			if ($config) {
+				if (!$check ||
+					$core->auth->isSuperAdmin() ||
+					$core->auth->check($core->plugins->moduleInfo($id,'permissions'),$core->blog->id))
+				{
+					$params = array('module' => $id,'conf' => '1');
+					if (!$core->plugins->moduleInfo($id,'standalone_config') && !$self) {
+						$params['redir'] = $core->adminurl->get('admin.plugin.'.$id);
+					}
+					$st[] = '<a class="module-config" href="'.
+						$core->adminurl->get('admin.plugins',$params).
+						'">'.__('Configure plugin').'</a>';
+				}
+			}
+			if (is_array($settings)) {
+				foreach ($settings as $sk => $sv) {
+					switch ($sk) {
+						case 'blog':
+							if (!$check ||
+								$core->auth->isSuperAdmin() ||
+								$core->auth->check('admin',$core->blog->id))
+							{
+								$st[] = '<a class="module-config" href="'.
+									$core->adminurl->get('admin.blog.pref').$sv.
+									'">'.__('Plugin settings (in blog parameters)').'</a>';
+							}
+							break;
+						case 'pref':
+							if (!$check ||
+								$core->auth->isSuperAdmin() ||
+								$core->auth->check('usage,contentadmin',$core->blog->id))
+							{
+								$st[] = '<a class="module-config" href="'.
+									$core->adminurl->get('admin.user.preferences').$sv.
+									'">'.__('Plugin settings (in user preferences)').'</a>';
+							}
+							break;
+						case 'self':
+							if ($self) {
+								if (!$check ||
+									$core->auth->isSuperAdmin() ||
+									$core->auth->check($core->plugins->moduleInfo($id,'permissions'),$core->blog->id))
+								{
+									$st[] = '<a class="module-config" href="'.
+										$core->adminurl->get('admin.plugin.'.$id).$sv.
+										'">'.__('Plugin settings').'</a>';
+								}
+							}
+							break;
+					}
+				}
+			}
+		}
+
+		return $st;
 	}
 
Index: inc/admin/lib.themeconfig.php
===================================================================
--- inc/admin/lib.themeconfig.php	(revision 2660)
+++ inc/admin/lib.themeconfig.php	(revision 3340)
@@ -71,5 +71,5 @@
 
 		// Eval font size in em (assume base font size in pixels equal to 16)
-		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex)?$/',$size,$m)) {
+		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex|rem)?$/',$size,$m)) {
 			if (empty($m[2])) {
 				$m[2] = 'em';
@@ -144,5 +144,5 @@
 	public static function adjustFontSize($s)
 	{
-		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex)?$/',$s,$m)) {
+		if (preg_match('/^([0-9.]+)\s*(%|pt|px|em|ex|rem)?$/',$s,$m)) {
 			if (empty($m[2])) {
 				$m[2] = 'em';
Index: inc/admin/prepend.php
===================================================================
--- inc/admin/prepend.php	(revision 3262)
+++ inc/admin/prepend.php	(revision 3375)
@@ -64,5 +64,5 @@
 }
 
-function addMenuItem($section,$desc,$adminurl,$icon,$perm)
+function addMenuItem($section,$desc,$adminurl,$icon,$perm,$pinned=false)
 {
 	global $core,$_menu;
@@ -70,5 +70,5 @@
 	$url = $core->adminurl->get($adminurl);
 	$_menu[$section]->prependItem($desc,$url,$icon,
-		preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm,null,null,true);
+		preg_match('/'.preg_quote($url).'(\?.*)?$/',$_SERVER['REQUEST_URI']),$perm,null,null,$pinned);
 }
 
@@ -180,4 +180,5 @@
 
 $core->adminurl->register('admin.posts','posts.php');
+$core->adminurl->register('admin.popup_posts','popup_posts.php');
 $core->adminurl->register('admin.post','post.php');
 $core->adminurl->register('admin.post.media','post_media.php');
@@ -278,5 +279,5 @@
 		$core->auth->check('usage,contentadmin',$core->blog->id));
 	addMenuItem('Blog',__('New entry'),'admin.post','images/menu/edit.png',
-		$core->auth->check('usage,contentadmin',$core->blog->id));
+		$core->auth->check('usage,contentadmin',$core->blog->id),true);
 
 	addMenuItem('System',__('Update'),'admin.update','images/menu/update.png',
Index: inc/core/class.dc.auth.php
===================================================================
--- inc/core/class.dc.auth.php	(revision 3298)
+++ inc/core/class.dc.auth.php	(revision 3340)
@@ -217,5 +217,5 @@
 		# Check here for user and IP address
 		$this->checkUser($_SESSION['sess_user_id']);
-		$uid = $uid ? $uid : http::browserUID(DC_MASTER_KEY);
+		$uid = $uid ?: http::browserUID(DC_MASTER_KEY);
 
 		$user_can_log = $this->userID() !== null && $uid == $_SESSION['sess_browser_uid'];
Index: inc/core/class.dc.blog.php
===================================================================
--- inc/core/class.dc.blog.php	(revision 3263)
+++ inc/core/class.dc.blog.php	(revision 3340)
@@ -1506,5 +1506,5 @@
 		$cur = $this->con->openCursor($this->prefix.'post');
 
-		$cur->cat_id = ($cat_id ? $cat_id : null);
+		$cur->cat_id = ($cat_id ?: null);
 		$cur->post_upddt = date('Y-m-d H:i:s');
 
@@ -1530,5 +1530,5 @@
 		$cur = $this->con->openCursor($this->prefix.'post');
 
-		$cur->cat_id = ($new_cat_id ? $new_cat_id : null);
+		$cur->cat_id = ($new_cat_id ?: null);
 		$cur->post_upddt = date('Y-m-d H:i:s');
 
Index: inc/core/class.dc.media.php
===================================================================
--- inc/core/class.dc.media.php	(revision 3354)
+++ inc/core/class.dc.media.php	(revision 3357)
@@ -393,5 +393,5 @@
 		}
 
-		$media_dir = $this->relpwd ? $this->relpwd : '.';
+		$media_dir = $this->relpwd ?: '.';
 
 		$strReq =
@@ -660,5 +660,5 @@
 	protected function rebuildDB($pwd)
 	{
-		$media_dir = $pwd ? $pwd : '.';
+		$media_dir = $pwd ?: '.';
 
 		$strReq =
@@ -919,5 +919,5 @@
 	public function getDBDirs()
 	{
-		$media_dir = $this->relpwd ? $this->relpwd : '.';
+		$media_dir = $this->relpwd ?: '.';
 
 		$strReq =
Index: inc/core/class.dc.modules.php
===================================================================
--- inc/core/class.dc.modules.php	(revision 3135)
+++ inc/core/class.dc.modules.php	(revision 3333)
@@ -283,5 +283,5 @@
 	(currently available keys : permissions, priority, type)
 	*/
-	public function registerModule($name,$desc,$author,$version, $properties = array())
+	public function registerModule($name,$desc,$author,$version,$properties = array())
 	{
 		if ($this->disabled_mode) {
@@ -320,5 +320,6 @@
 				'type' => null,
 				'enabled' => true,
-				'requires' => array()
+				'requires' => array(),
+				'settings' => array()
 			), $properties
 		);
Index: inc/core/class.dc.trackback.php
===================================================================
--- inc/core/class.dc.trackback.php	(revision 2674)
+++ inc/core/class.dc.trackback.php	(revision 3340)
@@ -171,5 +171,5 @@
 		$comment =
 		"<!-- TB -->\n".
-		'<p><strong>'.($title ? $title : $blog_name)."</strong></p>\n".
+		'<p><strong>'.($title ?: $blog_name)."</strong></p>\n".
 		'<p>'.$excerpt.'</p>';
 
Index: inc/core/class.dc.update.php
===================================================================
--- inc/core/class.dc.update.php	(revision 2566)
+++ inc/core/class.dc.update.php	(revision 3350)
@@ -104,14 +104,35 @@
 		{
 			$path = '';
-			$client = netHttp::initClient($this->url,$path);
-			if ($client !== false) {
-				$client->setTimeout(4);
-				$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
-				$client->get($path);
-
-				$this->readVersion($client->getContent());
-			}
-		}
-		catch (Exception $e) {}
+			$status = 0;
+
+			$http_get = function ($http_url) use (&$status,$path) {
+				$client = netHttp::initClient($http_url,$path);
+				if ($client !== false) {
+					$client->setTimeout(4);
+					$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
+					$client->get($path);
+					$status = (int) $client->getStatus();
+				}
+				return $client;
+			};
+
+			$client = $http_get($this->url);
+			if ($status >= 400) {
+				// If original URL uses HTTPS, try with HTTP
+				$url_parts = parse_url($client->getRequestURL());
+				if (isset($url_parts['scheme']) && $url_parts['scheme'] == 'https') {
+					// Replace https by http in url
+					$this->url = preg_replace('/^https(?=:\/\/)/i','http',$this->url);
+					$client = $http_get($this->url);
+				}
+			}
+			if (!$status || $status >= 400) {
+				throw new Exception();
+			}
+			$this->readVersion($client->getContent());
+		}
+		catch (Exception $e) {
+			return;
+		}
 
 		# Create cache
@@ -202,13 +223,32 @@
 		try
 		{
-			$client = netHttp::initClient($url,$path);
-			$client->setTimeout(4);
-			$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
-			$client->useGzip(false);
-			$client->setPersistReferers(false);
-			$client->setOutput($dest);
-			$client->get($path);
-
-			if ($client->getStatus() != 200) {
+			$path = '';
+			$status = 0;
+
+			$http_get = function ($http_url) use (&$status,$dest,$path) {
+				$client = netHttp::initClient($http_url,$path);
+				if ($client !== false) {
+					$client->setTimeout(4);
+					$client->setUserAgent($_SERVER['HTTP_USER_AGENT']);
+					$client->useGzip(false);
+					$client->setPersistReferers(false);
+					$client->setOutput($dest);
+					$client->get($path);
+					$status = (int) $client->getStatus();
+				}
+				return $client;
+			};
+
+			$client = $http_get($url);
+			if ($status >= 400) {
+				// If original URL uses HTTPS, try with HTTP
+				$url_parts = parse_url($client->getRequestURL());
+				if (isset($url_parts['scheme']) && $url_parts['scheme'] == 'https') {
+					// Replace https by http in url
+					$url = preg_replace('/^https(?=:\/\/)/i','http',$url);
+					$client = $http_get($url);
+				}
+			}
+			if ($status != 200) {
 				@unlink($dest);
 				throw new Exception();
